DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Adaptability

When the adaptivityEnabled property is set to true, JavaScript Scheduler elements adapt to small screens as follows:

  • Cell overflow indicators become larger to accommodate touch gestures.
  • The appointment list for a chosen date slides in from the edge of the screen.
  • The appointment details form occupies the entire screen.
  • Instead of the view switcher, a drop-down menu is used to switch between views. To open this menu, users should click or tap a button in the upper right corner.
Backend API
$(() => { const scheduler = $('#scheduler').dxScheduler({ timeZone: 'America/Los_Angeles', dataSource: data, views: ['week', 'month'], adaptivityEnabled: true, currentView: 'month', height: 590, currentDate: new Date(2021, 2, 25), startDayHour: 9, resources: [{ fieldExpr: 'priorityId', dataSource: priorities, label: 'Priority', icon: 'tags', }], }).dxScheduler('instance'); $('#speedDialAction').dxSpeedDialAction({ icon: 'plus', onClick() { scheduler.showAppointmentPopup(); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=25.2.6"></script> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="scheduler"></div> <div id="speedDialAction"></div> </div> </body> </html>
@media only screen and (max-width: 370px) { .dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-popup-bottom.dx-toolbar .dx-toolbar-items-container { height: auto; } .dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center { display: flex; flex-direction: column; } .dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button { padding: 0; } .dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button .dx-button { width: 200px; } .dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button:nth-child(1) { margin-bottom: 12px; } }
const data = [ { text: 'Website Re-Design Plan', startDate: new Date('2021-03-01T16:30:00.000Z'), endDate: new Date('2021-03-01T18:30:00.000Z'), recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;WKST=TU;INTERVAL=2;COUNT=32', }, { text: 'Book Flights to San Fran for Sales Trip', startDate: new Date('2021-03-01T16:30:00.000Z'), endDate: new Date('2021-03-01T18:30:00.000Z'), recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;INTERVAL=4;COUNT=32', allDay: true, priorityId: [1], }, { text: 'Install New Router in Dev Room', startDate: new Date('2021-03-01T16:30:00.000Z'), endDate: new Date('2021-03-01T18:30:00.000Z'), recurrenceRule: 'FREQ=WEEKLY;BYDAY=FR;INTERVAL=2;COUNT=32', }, { text: 'Approve Personal Computer Upgrade Plan', startDate: new Date('2021-02-10T17:00:00.000Z'), endDate: new Date('2021-02-10T18:00:00.000Z'), recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2;COUNT=32', priorityId: [2], }, { text: 'Final Budget Review', startDate: new Date('2021-04-01T19:00:00.000Z'), endDate: new Date('2021-04-01T20:35:00.000Z'), }, { text: 'New Brochures', startDate: new Date('2021-04-01T21:30:00.000Z'), endDate: new Date('2021-04-01T22:45:00.000Z'), }, { text: 'Install New Database', startDate: new Date('2021-04-01T16:45:00.000Z'), endDate: new Date('2021-04-01T18:15:00.000Z'), }, { text: 'Approve New Online Marketing Strategy', startDate: new Date('2021-04-01T19:00:00.000Z'), endDate: new Date('2021-04-01T21:00:00.000Z'), }, { text: 'Upgrade Personal Computers', startDate: new Date('2021-04-01T22:15:00.000Z'), endDate: new Date('2021-04-01T23:30:00.000Z'), }, { text: 'Upgrade Personal Computers', startDate: new Date('2021-04-02T22:15:00.000Z'), endDate: new Date('2021-04-02T23:30:00.000Z'), }, ]; const priorities = [ { text: 'High priority', id: 1, color: '#cc5c53', }, { text: 'Low priority', id: 2, color: '#ff9747', }, ];

In this demo, we also added the floating action button as an alternative way to create a new appointment. The button is implemented with the SpeedDialAction component.

Backend API
import React, { useCallback, useRef } from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import type { SchedulerTypes, SchedulerRef } from 'devextreme-react/scheduler';
import SpeedDialAction from 'devextreme-react/speed-dial-action';
import { data, priorities } from './data.ts';
const views: SchedulerTypes.ViewType[] = ['week', 'month'];
const cellDuration = 30;
const currentDate = new Date(2021, 2, 25);
const App = () => {
const schedulerRef = useRef<SchedulerRef>(null);
const showAppointmentPopup = useCallback(() => {
schedulerRef.current?.instance().showAppointmentPopup();
}, []);
return (
<>
<Scheduler
ref={schedulerRef}
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
adaptivityEnabled={true}
defaultCurrentView="month"
defaultCurrentDate={currentDate}
cellDuration={cellDuration}
height={590}
startDayHour={9}
>
<Resource
dataSource={priorities}
fieldExpr="priorityId"
label="Priority"
icon="tags"
/>
</Scheduler>
<SpeedDialAction
icon="plus"
onClick={showAppointmentPopup}
/>
</>
);
};
export default App;
import React, { useCallback, useRef } from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import SpeedDialAction from 'devextreme-react/speed-dial-action';
import { data, priorities } from './data.js';
const views = ['week', 'month'];
const cellDuration = 30;
const currentDate = new Date(2021, 2, 25);
const App = () => {
const schedulerRef = useRef(null);
const showAppointmentPopup = useCallback(() => {
schedulerRef.current?.instance().showAppointmentPopup();
}, []);
return (
<>
<Scheduler
ref={schedulerRef}
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
adaptivityEnabled={true}
defaultCurrentView="month"
defaultCurrentDate={currentDate}
cellDuration={cellDuration}
height={590}
startDayHour={9}
>
<Resource
dataSource={priorities}
fieldExpr="priorityId"
label="Priority"
icon="tags"
/>
</Scheduler>
<SpeedDialAction
icon="plus"
onClick={showAppointmentPopup}
/>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
type Appointment = SchedulerTypes.Appointment & { priorityId?: number[]; };
type Resource = {
text: string;
id: number;
color: string;
};
export const data: Appointment[] = [
{
text: 'Website Re-Design Plan',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;WKST=TU;INTERVAL=2;COUNT=32',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;INTERVAL=4;COUNT=32',
allDay: true,
priorityId: [1],
}, {
text: 'Install New Router in Dev Room',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=FR;INTERVAL=2;COUNT=32',
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-02-10T17:00:00.000Z'),
endDate: new Date('2021-02-10T18:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2;COUNT=32',
priorityId: [2],
}, {
text: 'Final Budget Review',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T20:35:00.000Z'),
}, {
text: 'New Brochures',
startDate: new Date('2021-04-01T21:30:00.000Z'),
endDate: new Date('2021-04-01T22:45:00.000Z'),
}, {
text: 'Install New Database',
startDate: new Date('2021-04-01T16:45:00.000Z'),
endDate: new Date('2021-04-01T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-01T22:15:00.000Z'),
endDate: new Date('2021-04-01T23:30:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-02T22:15:00.000Z'),
endDate: new Date('2021-04-02T23:30:00.000Z'),
},
];
export const priorities: Resource[] = [
{
text: 'High priority',
id: 1,
color: '#cc5c53',
}, {
text: 'Low priority',
id: 2,
color: '#ff9747',
},
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{
text: 'Website Re-Design Plan',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;WKST=TU;INTERVAL=2;COUNT=32',
},
{
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;INTERVAL=4;COUNT=32',
allDay: true,
priorityId: [1],
},
{
text: 'Install New Router in Dev Room',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=FR;INTERVAL=2;COUNT=32',
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-02-10T17:00:00.000Z'),
endDate: new Date('2021-02-10T18:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2;COUNT=32',
priorityId: [2],
},
{
text: 'Final Budget Review',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T20:35:00.000Z'),
},
{
text: 'New Brochures',
startDate: new Date('2021-04-01T21:30:00.000Z'),
endDate: new Date('2021-04-01T22:45:00.000Z'),
},
{
text: 'Install New Database',
startDate: new Date('2021-04-01T16:45:00.000Z'),
endDate: new Date('2021-04-01T18:15:00.000Z'),
},
{
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T21:00:00.000Z'),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-01T22:15:00.000Z'),
endDate: new Date('2021-04-01T23:30:00.000Z'),
},
{
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-02T22:15:00.000Z'),
endDate: new Date('2021-04-02T23:30:00.000Z'),
},
];
export const priorities = [
{
text: 'High priority',
id: 1,
color: '#cc5c53',
},
{
text: 'Low priority',
id: 2,
color: '#ff9747',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
@media only screen and (max-width: 370px) {
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-popup-bottom.dx-toolbar .dx-toolbar-items-container {
height: auto;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center {
display: flex;
flex-direction: column;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button {
padding: 0;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button .dx-button {
width: 200px;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button:nth-child(1) {
margin-bottom: 12px;
}
}
In this demo, we also added the floating action button as an alternative way to create a new appointment. The button is implemented with the SpeedDialAction component.

-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Scheduler - Adaptability
When the adaptivityEnabled property is set to true, Scheduler elements adapt to small screens as follows:
- Cell overflow indicators become larger to accommodate touch gestures.
- The appointment list for a chosen date slides in from the edge of the screen.
- The appointment details form occupies the entire screen.
- Instead of the view switcher, a drop-down menu is used to switch between views. To open this menu, users should click or tap a button in the upper right corner.
Backend API
<template>
<div>
<DxScheduler
ref="schedulerRef"
time-zone="America/Los_Angeles"
:data-source="dataSource"
:current-date="currentDate"
:cell-duration="cellDuration"
:views="views"
:height="590"
:start-day-hour="9"
:adaptivity-enabled="true"
current-view="month"
>
<DxResource
:data-source="priorities"
field-expr="priorityId"
label="Priority"
icon="tags"
/>
</DxScheduler>
<DxSpeedDialAction
:on-click="showPopup"
icon="plus"
/>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxScheduler, { DxResource } from 'devextreme-vue/scheduler';
import DxSpeedDialAction from 'devextreme-vue/speed-dial-action';
import { data, priorities } from './data.ts';
const views = ['week', 'month'];
const currentDate = new Date(2021, 2, 25);
const cellDuration = 30;
const dataSource = data;
const schedulerRef = ref<DxScheduler>();
function showPopup() {
schedulerRef.value?.instance?.showAppointmentPopup();
}
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const data = [
{
text: 'Website Re-Design Plan',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;WKST=TU;INTERVAL=2;COUNT=32',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;INTERVAL=4;COUNT=32',
allDay: true,
priorityId: [1],
}, {
text: 'Install New Router in Dev Room',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=FR;INTERVAL=2;COUNT=32',
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-02-10T17:00:00.000Z'),
endDate: new Date('2021-02-10T18:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2;COUNT=32',
priorityId: [2],
}, {
text: 'Final Budget Review',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T20:35:00.000Z'),
}, {
text: 'New Brochures',
startDate: new Date('2021-04-01T21:30:00.000Z'),
endDate: new Date('2021-04-01T22:45:00.000Z'),
}, {
text: 'Install New Database',
startDate: new Date('2021-04-01T16:45:00.000Z'),
endDate: new Date('2021-04-01T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-01T22:15:00.000Z'),
endDate: new Date('2021-04-01T23:30:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-02T22:15:00.000Z'),
endDate: new Date('2021-04-02T23:30:00.000Z'),
},
];
export const priorities = [
{
text: 'High priority',
id: 1,
color: '#cc5c53',
}, {
text: 'Low priority',
id: 2,
color: '#ff9747',
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
@media only screen and (max-width: 370px) {
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-popup-bottom.dx-toolbar .dx-toolbar-items-container {
height: auto;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center {
display: flex;
flex-direction: column;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button {
padding: 0;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button .dx-button {
width: 200px;
}
.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button:nth-child(1) {
margin-bottom: 12px;
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
In this demo, we also added the floating action button as an alternative way to create a new appointment. The button is implemented with the SpeedDialAction component.

Backend API
<dx-scheduler
[dataSource]="appointments"
[views]="['week', 'month']"
timeZone="America/Los_Angeles"
currentView="month"
[adaptivityEnabled]="true"
[(currentDate)]="currentDate"
[cellDuration]="cellDuration"
[startDayHour]="9"
[height]="590"
>
<dxi-scheduler-resource
fieldExpr="priorityId"
label="Priority"
[dataSource]="priorities"
icon="tags"
>
</dxi-scheduler-resource>
</dx-scheduler>
<dx-speed-dial-action
#speedDialAction
icon="plus"
(onClick)="showAppointmentPopup()"
>
</dx-speed-dial-action>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ViewChild, provideZoneChangeDetection } from '@angular/core';
import { DxSpeedDialActionModule, DxSchedulerModule, DxSchedulerComponent } from 'devextreme-angular';
import { Appointment, Resource, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSchedulerModule,
DxSpeedDialActionModule,
],
})
export class AppComponent {
@ViewChild(DxSchedulerComponent, { static: false }) scheduler: DxSchedulerComponent;
appointments: Appointment[];
currentDate: Date = new Date(2021, 2, 25);
cellDuration = 30;
priorities: Resource[];
constructor(service: Service) {
this.appointments = service.getAppointments();
this.priorities = service.getResources();
}
showAppointmentPopup() {
this.scheduler.instance.showAppointmentPopup();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
@media only screen and (max-width: 370px) {
::ng-deep.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-popup-bottom.dx-toolbar .dx-toolbar-items-container {
height: auto;
}
::ng-deep.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center {
display: flex;
flex-direction: column;
}
::ng-deep.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button {
padding: 0;
}
::ng-deep.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button .dx-button {
width: 200px;
}
::ng-deep.dx-popup:not(.dx-scheduler-appointment-popup) .dx-dialog .dx-toolbar-items-container .dx-toolbar-center .dx-toolbar-button:nth-child(1) {
margin-bottom: 12px;
}
}
import { Injectable } from '@angular/core';
export class Appointment {
text: string;
startDate: Date;
endDate: Date;
recurrenceRule?: string;
allDay?: boolean;
priorityId?: number[];
}
export class Resource {
text: string;
id: number;
color?: string;
}
const appointments: Appointment[] = [
{
text: 'Website Re-Design Plan',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;WKST=TU;INTERVAL=2;COUNT=32',
}, {
text: 'Book Flights to San Fran for Sales Trip',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,FR;INTERVAL=4;COUNT=32',
allDay: true,
priorityId: [1],
}, {
text: 'Install New Router in Dev Room',
startDate: new Date('2021-03-01T16:30:00.000Z'),
endDate: new Date('2021-03-01T18:30:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=FR;INTERVAL=2;COUNT=32',
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: new Date('2021-02-10T17:00:00.000Z'),
endDate: new Date('2021-02-10T18:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2;COUNT=32',
priorityId: [2],
}, {
text: 'Final Budget Review',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T20:35:00.000Z'),
}, {
text: 'New Brochures',
startDate: new Date('2021-04-01T21:30:00.000Z'),
endDate: new Date('2021-04-01T22:45:00.000Z'),
}, {
text: 'Install New Database',
startDate: new Date('2021-04-01T16:45:00.000Z'),
endDate: new Date('2021-04-01T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
startDate: new Date('2021-04-01T19:00:00.000Z'),
endDate: new Date('2021-04-01T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-01T22:15:00.000Z'),
endDate: new Date('2021-04-01T23:30:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
startDate: new Date('2021-04-02T22:15:00.000Z'),
endDate: new Date('2021-04-02T23:30:00.000Z'),
},
];
const priorities: Resource[] = [
{
text: 'High priority',
id: 1,
color: '#cc5c53',
}, {
text: 'Low priority',
id: 2,
color: '#ff9747',
},
];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
getResources(): Resource[] {
return priorities;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
In this demo, we also added the floating action button as an alternative way to create a new appointment. The button is implemented with the SpeedDialAction component.